import React from 'react';
import styled from 'styled-components';
import { Table, TableHeader, TableRow, TableHeaderCell, TableBody, } from "../../../elements/Table/Table";
import { SESSION_LIST_SIZE } from '../../consts';
import { useFetchUsers } from '../../hooks';
import { SessionListHeader } from './SessionListHeader';
import { SessionItem } from './SessionItem';
import { SessionListLoader } from './SessionListLoader';
import { TableWrapper, PlaceholderWrapper, SessionListContainer, } from './styles';
export var SessionList = function (_a) {
    var listData = _a.listData, aie = _a.aie;
    var sessions = listData.sessions, loading = listData.loading, error = listData.error;
    var users = useFetchUsers().users;
    if (error) {
        return (React.createElement(React.Fragment, null,
            React.createElement(SessionListHeader, { listData: listData }),
            React.createElement(PlaceholderWrapper, null,
                React.createElement("p", null, "Error occurred while loading sessions. Please try again later"))));
    }
    var shouldDisplayLoader = loading || typeof sessions === 'undefined';
    return (React.createElement(SessionListContainer, null,
        React.createElement(SessionListHeader, { listData: listData }),
        shouldDisplayLoader ? (React.createElement(SessionListLoader, { count: SESSION_LIST_SIZE })) : (React.createElement(TableWrapper, null, sessions.length > 0 ? (React.createElement(SessionTable, null,
            React.createElement(TableHeader, null,
                React.createElement(TableRow, null,
                    React.createElement(TableHeaderCell, { small: true }, "Name"),
                    React.createElement(TableHeaderCell, { small: true }, "Progress"),
                    React.createElement(TableHeaderCell, { small: true, paddingX: 0.5 }, "Information"),
                    React.createElement(TableHeaderCell, { small: true }, "Action"))),
            React.createElement(TableBody, null, sessions.map(function (session) { return (React.createElement(SessionItem, { key: session.id, session: session, sme: !aie, users: users })); })))) : (React.createElement(PlaceholderWrapper, null,
            React.createElement("p", null, "No tasks available")))))));
};
var SessionTable = styled(Table).withConfig({ displayName: "SessionTable", componentId: "sc-jarjlz" })({
    tableLayout: 'fixed',
});
