import styled from 'styled-components';
import defaultCreatedTheme from "../../../theme";
var sizes = {
    mini: '35px',
    tiny: '80px',
    small: '150px',
    medium: '300px',
    large: '450px',
    big: '600px',
    huge: '800px',
    massive: '960px',
};
export var Image = styled.img.withConfig({ displayName: "Image", componentId: "sc-hl1mae" })({}, function (_a) {
    var size = _a.size, avatar = _a.avatar, theme = _a.theme;
    // Different scale used for for avatar
    if (avatar) {
        return { fontSize: theme.sizes.scale[size || 'mini'], height: 'auto' };
    }
    if (!size) {
        return;
    }
    return {
        width: sizes[size],
        height: 'auto',
    };
}, function (_a) {
    var avatar = _a.avatar;
    return avatar ? { borderRadius: '50%', width: '4em', margin: '0.5em' } : null;
});
Image.defaultProps = { theme: defaultCreatedTheme };
