var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
import styled, { css } from 'styled-components';
import React from 'react';
import { Icon } from '../Icon';
import defaultCreatedTheme from '../../../theme';
export var PanelWrapper = styled.div.withConfig({ displayName: "PanelWrapper", componentId: "sc-ueoeaj" })(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  display: flex;\n  flex-direction: column;\n  width: 100%;\n  height: 100%;\n  overflow: hidden;\n  ", "\n"], ["\n  display: flex;\n  flex-direction: column;\n  width: 100%;\n  height: 100%;\n  overflow: hidden;\n  ",
    "\n"])), function (_a) {
    var theme = _a.theme;
    return css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n    border: 1px solid ", ";\n    background-color: ", ";\n    border-radius: ", ";\n  "], ["\n    border: 1px solid ", ";\n    background-color: ", ";\n    border-radius: ", ";\n  "])), theme.greyscale.dark, theme.colors.white.default, theme.sizes.borderRadius);
});
export var PanelBody = styled.div.withConfig({ displayName: "PanelBody", componentId: "sc-1y5t0a8" })(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  flex-grow: 1;\n  display: flex;\n  flex-direction: column;\n  overflow-y: auto;\n"], ["\n  flex-grow: 1;\n  display: flex;\n  flex-direction: column;\n  overflow-y: auto;\n"])));
export var PanelFooter = styled.div.withConfig({ displayName: "PanelFooter", componentId: "sc-me86f1" })(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  min-height: 72px;\n  border-top: 1px solid ", ";\n  display: flex;\n  align-items: center;\n"], ["\n  min-height: 72px;\n  border-top: 1px solid ", ";\n  display: flex;\n  align-items: center;\n"])), function (_a) {
    var theme = _a.theme;
    return theme.greyscale.dark;
});
export var PanelHeaderWrapper = styled.div.withConfig({ displayName: "PanelHeaderWrapper", componentId: "sc-14chizs" })(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n  height: 36px;\n  padding-left: 8px;\n  display: flex;\n  align-items: center;\n  justify-content: space-between;\n  flex-shrink: 0;\n  ", "\n"], ["\n  height: 36px;\n  padding-left: 8px;\n  display: flex;\n  align-items: center;\n  justify-content: space-between;\n  flex-shrink: 0;\n  ",
    "\n"])), function (_a) {
    var theme = _a.theme;
    return css(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n    background-color: ", ";\n    color: ", ";\n  "], ["\n    background-color: ", ";\n    color: ", ";\n  "])), theme.colors.primary.default, theme.colors.white.default);
});
export var PanelHeaderTitle = styled.div.withConfig({ displayName: "PanelHeaderTitle", componentId: "sc-qe2mkm" })(templateObject_8 || (templateObject_8 = __makeTemplateObject(["\n  display: flex;\n  ", "\n  align-items: center;\n  font-weight: 600;\n  & > :first-child {\n    margin: 0 8px;\n  }\n"], ["\n  display: flex;\n  ",
    "\n  align-items: center;\n  font-weight: 600;\n  & > :first-child {\n    margin: 0 8px;\n  }\n"])), function (_a) {
    var stretched = _a.stretched;
    return stretched && css(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n      width: 100%;\n    "], ["\n      width: 100%;\n    "])));
});
export var PanelHeaderButtonWrapper = styled.div.withConfig({ displayName: "PanelHeaderButtonWrapper", componentId: "sc-1mue96f" })(templateObject_9 || (templateObject_9 = __makeTemplateObject(["\n  height: 100%;\n  display: flex;\n"], ["\n  height: 100%;\n  display: flex;\n"])));
export var PanelHeaderButton = styled.button.withConfig({ displayName: "PanelHeaderButton", componentId: "sc-1ktnmio" })(templateObject_11 || (templateObject_11 = __makeTemplateObject(["\n  flex: 1 0 auto;\n  padding: 11px 5px;\n  background-color: transparent;\n  border: none;\n  cursor: pointer;\n  font-weight: 600;\n  ", "\n"], ["\n  flex: 1 0 auto;\n  padding: 11px 5px;\n  background-color: transparent;\n  border: none;\n  cursor: pointer;\n  font-weight: 600;\n  ",
    "\n"])), function (_a) {
    var highlightedHover = _a.highlightedHover, separated = _a.separated, theme = _a.theme;
    return css(templateObject_10 || (templateObject_10 = __makeTemplateObject(["\n    ", "\n    color: ", ";\n    ", "\n    &:last-child {\n      border-top-right-radius: ", ";\n    }\n  "], ["\n    ", "\n    color: ", ";\n    ",
        "\n    &:last-child {\n      border-top-right-radius: ", ";\n    }\n  "])), separated && 'border-left: 1px solid ' + theme.colors.white.default + ';', theme.colors.white.default, highlightedHover &&
        "&:hover {\n        background-color: " + theme.colors.white.default + ";\n        color: " + theme.colors.primary.default + ";\n        box-shadow: inset 0 -1px 0 0 " + theme.greyscale.dark + ";\n      }", theme.sizes.borderRadius);
});
PanelHeaderButton.defaultProps = {
    theme: defaultCreatedTheme,
    separated: true,
    highlightedHover: true,
};
PanelHeaderWrapper.defaultProps = {
    theme: defaultCreatedTheme,
};
PanelWrapper.defaultProps = {
    theme: defaultCreatedTheme,
};
PanelFooter.defaultProps = {
    theme: defaultCreatedTheme,
};
export var PanelHeader = function (_a) {
    var headerActions = _a.headerActions, children = _a.children;
    var headerActionsComponent = headerActions === null || headerActions === void 0 ? void 0 : headerActions.map(function (_a, index) {
        var action = _a.action, highlightedHover = _a.highlightedHover, title = _a.title, icon = _a.icon, separated = _a.separated;
        var renderedIcon;
        if (icon) {
            if (typeof icon === 'string') {
                renderedIcon = React.createElement(Icon, { inheritColor: true, name: icon });
            }
            else {
                renderedIcon = icon;
            }
        }
        return (React.createElement(PanelHeaderButton, { highlightedHover: highlightedHover, key: index + "-" + title, onClick: action, separated: separated },
            title,
            " ",
            React.createElement("span", null, renderedIcon)));
    });
    return (React.createElement(PanelHeaderWrapper, null,
        React.createElement(PanelHeaderTitle, { stretched: !headerActionsComponent }, children),
        React.createElement(PanelHeaderButtonWrapper, null, headerActionsComponent)));
};
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8, templateObject_9, templateObject_10, templateObject_11;
