var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useCallback, useState } from 'react';
import styled from 'styled-components';
import defaultTheme from "../../../theme";
import { Icon } from "../../elements";
/**
 * Hidden checkbox
 */
var HiddenCheckbox = styled.input.attrs({ type: 'checkbox' })(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  // Hide checkbox visually but remain accessible to screen readers.\n  // Source: https://polished.js.org/docs/#hidevisually\n  border: 0;\n  clip: rect(0 0 0 0);\n  clippath: inset(50%);\n  height: 1px;\n  margin: -1px;\n  overflow: hidden;\n  padding: 0;\n  position: absolute;\n  white-space: nowrap;\n  width: 1px;\n"], ["\n  // Hide checkbox visually but remain accessible to screen readers.\n  // Source: https://polished.js.org/docs/#hidevisually\n  border: 0;\n  clip: rect(0 0 0 0);\n  clippath: inset(50%);\n  height: 1px;\n  margin: -1px;\n  overflow: hidden;\n  padding: 0;\n  position: absolute;\n  white-space: nowrap;\n  width: 1px;\n"])));
var CustomCheckbox = styled.div.withConfig({ displayName: "CustomCheckbox", componentId: "sc-1o2kqox" })({
    width: '20px',
    height: '20px',
    display: 'flex',
    justifyContent: 'center',
    alignItems: 'center',
    position: 'relative',
    borderRadius: '5px',
}, 
// Themed
function (_a) {
    var theme = _a.theme, color = _a.color, checked = _a.checked;
    return ({
        border: "1px solid " + (checked
            ? theme.colors[color || 'primary'].default
            : theme.greyscale.medium),
    });
}, 
// Add margin for label
function (_a) {
    var hasLabel = _a.hasLabel;
    return hasLabel
        ? {
            marginRight: '0.5em',
        }
        : null;
});
CustomCheckbox.defaultProps = {
    theme: defaultTheme,
};
/**
 * Checkbox
 */
export var Checkbox = styled(function (_a) {
    var className = _a.className, children = _a.children, checked = _a.checked, onChange = _a.onChange, theme = _a.theme, color = _a.color, inheritColor = _a.inheritColor, rest = __rest(_a, ["className", "children", "checked", "onChange", "theme", "color", "inheritColor"]);
    var isControlled = checked !== undefined;
    var _b = useState(false), currentValue = _b[0], setCurrentValue = _b[1];
    var usedValue = isControlled ? checked : currentValue;
    var handleChange = useCallback(function (e) {
        if (!isControlled) {
            setCurrentValue(e.target.checked);
            return;
        }
        if (onChange) {
            onChange(e);
        }
    }, [onChange, isControlled]);
    return (React.createElement("div", { className: className },
        React.createElement("label", null,
            React.createElement(CustomCheckbox, { color: color, checked: usedValue, hasLabel: !!children }, usedValue && (React.createElement(Icon, { name: "check", size: "small", color: color, inheritColor: inheritColor, fitted: true }))),
            React.createElement(HiddenCheckbox, __assign({}, rest, { checked: usedValue, onChange: handleChange })),
            children)));
}).withConfig({ displayName: "Checkbox", componentId: "sc-46fvqm" })({
    display: 'inline-block',
    alignSelf: 'flex-start',
    flexShrink: 0,
}, function (_a) {
    var _b;
    var theme = _a.theme;
    return ({
        '& > label': {
            display: 'flex',
            alignItems: 'center',
            justifyContent: 'start',
            cursor: 'pointer',
            '&:focus, &:focus:hover, &:hover': (_b = {},
                _b[CustomCheckbox] = {
                    borderColor: theme.colors.primary.default,
                },
                _b),
        },
    });
});
Checkbox.defaultProps = {
    theme: defaultTheme,
};
var templateObject_1;
