var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import styled from 'styled-components';
import { Ellipsis } from "../../components/elements/Ellipsis";
import { isParticipantInReview, isReviewer, isReviewRequested, allReviewersAreParticipants, getReviewerIds, getParticipantIds, } from '../utils';
import { SessionReviewersPopover } from '../SessionReviewersPopover';
var SessionComments = styled(function (_a) {
    var openComments = _a.openComments, commentsText = _a.commentsText, rest = __rest(_a, ["openComments", "commentsText"]);
    return (React.createElement("div", __assign({ onClick: openComments }, rest), commentsText));
}).withConfig({ displayName: "SessionComments", componentId: "sc-av9vxo" })(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  color: ", ";\n  cursor: pointer;\n  font-size: 12px;\n\n  &:hover {\n    text-decoration: underline;\n  }\n"], ["\n  color: ", ";\n  cursor: pointer;\n  font-size: 12px;\n\n  &:hover {\n    text-decoration: underline;\n  }\n"])), function (_a) {
    var theme = _a.theme;
    return theme.colors.primary.default;
});
var FlexElement = styled(function (_a) {
    var children = _a.children, rest = __rest(_a, ["children"]);
    return React.createElement("div", __assign({}, rest), children);
}).withConfig({ displayName: "FlexElement", componentId: "sc-2vf8bf" })(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  display: flex;\n\n  & > div {\n    min-width: 5px;\n    display: flex;\n    align-items: center;\n  }\n"], ["\n  display: flex;\n\n  & > div {\n    min-width: 5px;\n    display: flex;\n    align-items: center;\n  }\n"])));
var SessionStatusBox = styled('div').withConfig({ displayName: "SessionStatusBox", componentId: "sc-614u1q" })(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  display: flex;\n  flex-direction: column;\n  line-height: 1.2em;\n"], ["\n  display: flex;\n  flex-direction: column;\n  line-height: 1.2em;\n"])));
function getText(_a, sme, currentUserId, reviewerIds, participantIds) {
    var commentsCount = _a.commentsCount, handedOver = _a.handedOver, teachingOwnerId = _a.teachingOwnerId, conversionOwnerId = _a.conversionOwnerId;
    var reviewer = isReviewer(currentUserId, reviewerIds);
    if (reviewer) {
        var participant = isParticipantInReview(currentUserId, participantIds);
        if (participant) {
            return 'Review delivered';
        }
        return 'Review required';
    }
    if (!teachingOwnerId) {
        return 'No teaching started';
    }
    if (!conversionOwnerId && !sme) {
        return 'No conversion started';
    }
    var reviewRequested = isReviewRequested(reviewerIds);
    if (reviewRequested) {
        var allReviewersCompleted = allReviewersAreParticipants(reviewerIds, participantIds);
        if (allReviewersCompleted) {
            return 'Review completed';
        }
        return 'Review requested';
    }
    return 'No review required';
}
export var SessionStatus = function (_a) {
    var session = _a.session, _b = _a.sme, sme = _b === void 0 ? false : _b, currentUserId = _a.currentUserId, _c = _a.reviewers, reviewers = _c === void 0 ? [] : _c, openApp = _a.openApp, onClick = _a.onClick, tip = _a.tip;
    var reviewerIds = getReviewerIds(sme, session);
    var participantIds = getParticipantIds(sme, session);
    var text = getText(session, sme, currentUserId, reviewerIds, participantIds);
    var _d = session.commentsCount, commentsCount = _d === void 0 ? 0 : _d;
    var commentsText = commentsCount + " comment" + (commentsCount > 1 ? 's' : '');
    var sessionComments = commentsCount > 0 && (React.createElement(SessionComments, { openComments: openApp, commentsText: commentsText }));
    return (React.createElement(SessionStatusBox, null,
        React.createElement(FlexElement, null,
            React.createElement("div", null,
                React.createElement(Ellipsis, null, text)),
            reviewers.length > 0 && (React.createElement("div", null,
                React.createElement(SessionReviewersPopover, { reviewers: reviewers, tip: tip, onClick: onClick })))),
        sessionComments));
};
var templateObject_1, templateObject_2, templateObject_3;
